<template>
  <div class="my-wrap">
    <div class="login">
      <h3>Login</h3>
      <form id='loginForm' novalidate @submit.prevent="validateForm">
        <div class="msg-login" v-if="message!==''">{{message}}</div>
        <md-field :class="getValidationClass('username')">
          <label for="username">Username</label>
          <md-input
            type="text"
            name="username"
            id="username"
            v-model="form.username"
            :disabled="sending"
          />
          <span class="md-error" v-if="!$v.form.username.required">The username is required</span>
        </md-field>
        <md-field :class="getValidationClass('password')">
          <label for="password">Password</label>
          <md-input
            type="password"
            name="password"
            id="password"
            v-model="form.password"
            :disabled="sending"
          />
          <span class="md-error" v-if="!$v.form.password.required">The password is required</span>
        </md-field>
        <md-button id="login-btn" type="submit" class="md-primary" :disabled="sending">Login</md-button>
      </form>
    </div>
  </div>
</template>

<script>
import { validationMixin } from "vuelidate";
import ApiService from "@/services/ApiService.js";
import { required } from "vuelidate/lib/validators";

export default {
  name: "LoginComponent",
  mixins: [validationMixin],
  data: () => ({
    form: {
      username: null,
      password: null
    },
    sending: false,
    message: ""
  }),
  validations: {
    form: {
      username: {
        required
      },
      password: {
        required
      }
    }
  },
  methods: {
    getValidationClass(fieldName) {
      const field = this.$v.form[fieldName];

      if (field) {
        return {
          "md-invalid": field.$invalid && field.$dirty
        };
      }
    },
    clearForm() {
      this.$v.$reset();
      this.form.username = null;
      this.form.password = null;
    },
    
    async login() {
      this.sending = true;
      const payload = {
        username: this.form.username.toLowerCase(),
        password: this.form.password
      };

      let response;
      try {
        response = await ApiService.login(payload);
        this.message = response.msg;
      } catch (error) {
        this.message = error;
      }
      this.sending = false;
    },
    validateForm() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.login();
      }
    }
  }
};
</script>

<style scoped>
.my-wrap {
  display: flex;
  justify-content: center;
  align-items: center;
  width: 100%;
  height: 100%;
}
.msg-login {
  margin: 10px;
  padding: 5px;
  border: 1px solid;
  border-radius: 5px;
  display: flex;
  color: #856404;
  background-color: #fff3cd;
  border-color: #ffeeba;
}
.md-card {
  width: 320px;
  /* margin: 4px; */
  -webkit-box-pack: center;
  display: inline-block;
  vertical-align: top;
}
.login {
  align-items: center;
  display: flex;
  flex-direction: column;
  display: flex;
  flex-direction: column;
  justify-content: center;
  width: 300px;
  height: fit-content;
}
.md-progress-bar {
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
}
</style>